#include <string>
#include <admin>
#include <adminlib>

new g_block;
new g_override;
new g_SpecMode[MAX_PLAYERS];
new g_UserMenu[MAX_PLAYERS];

public plugin_init() {
	plugin_registerinfo("TEAMSELECT BLOCK","Blocks teamselect menu","1.0");
	plugin_registercmd("chooseteam","chooseteam",ACCESS_ALL);
	plugin_registercmd("jointeam","chooseteam",ACCESS_ALL);
	plugin_registercmd("specmode","specmode",ACCESS_ALL);
	plugin_registercmd("admin_tb","admin_team_block",ACCESS_CONFIG,"admin_tb 0/1: Turns chooseteam/jointeam block off/on");
	plugin_registercmd("admin_tb_ct","admin_changeteam",ACCESS_CONFIG,"admin_tb_ct [player]:  Sends player to team counter-terrorists");
	plugin_registercmd("admin_tb_t","admin_changeteam",ACCESS_CONFIG,"admin_tb_t [player]:  Sends player to team terrorists");
	plugin_registercmd("admin_tb_spec","admin_changeteam",ACCESS_CONFIG,"admin_tb_spec [player]:  Sends player to spectator");
	plugin_registercmd("admin_tb_specall","admin_tb_specall",ACCESS_CONFIG,"admin_tb_specall:  Sends all players to spectator");
	return PLUGIN_CONTINUE;
}

//Function to block teamselect
public admin_team_block(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new iData;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	iData=strtonum(Data);
	//START	
	if(iData){
		g_block=1;
		selfmessage("[TEAMSELECT MENU] Teamselect Menu disabled!");
	//STOP
	}else{
		g_block=0;
		reset_all();
		selfmessage("[TEAMSELECT MENU] Teamselect Menu enabled!");
	}
	return PLUGIN_HANDLED;
}


//Send player to Spectator on enter the server
public specmode(HLCommand,HLData,HLUserName,UserIndex) {
	new User[MAX_NAME_LENGTH];
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if(g_block && !g_SpecMode[UserIndex]){
		g_SpecMode[UserIndex]=1;
		g_override=1;
		execclient(User,"jointeam 6");
		welcome_menu(User,UserIndex);
	}
	return PLUGIN_CONTINUE;
}

//Admin can switch players
public admin_changeteam(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	

	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);

	strstripquotes(Data);

	if(!getvar("allow_client_exec")) {
		selfmessage("You cannot use this command because allow_client_exec is 0.");
	} else if(!check_user(Data)) {
		selfmessage("Unrecognized player: ");
		selfmessage(Data);
	} else {
		get_username(Data,TargetName,MAX_NAME_LENGTH);
		if(!strcmp(Command,"admin_tb_ct")) {
			g_override=1;
			execclient(TargetName, "jointeam 2");
		}else if(!strcmp(Command,"admin_tb_t")) {
			g_override=1;
			execclient(TargetName, "jointeam 1");
		}else if(!strcmp(Command,"admin_tb_spec")) {
			g_override=1;
			execclient(TargetName, "jointeam 6");
		}
	}
   	return PLUGIN_HANDLED;
}

//Admin can switch all players to spectator
public admin_tb_specall(HLCommand,HLData,HLUserName,UserIndex) {
	new Target[MAX_NAME_LENGTH];
	new maxplayers=maxplayercount();
	new i;
	new iDead;
	new iTeam;
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Target,MAX_NAME_LENGTH,_,_,iTeam,iDead)){
			g_override=1;
			if(!iDead){
				execclient(Target,"kill");
			}
			if(iTeam<=2){
				execclient(Target,"jointeam 6");
			}
		}
	}	
	return PLUGIN_HANDLED;
}

//Hook jointeam and chooseteam
public chooseteam(HLCommand,HLData,HLUserName,UserIndex) {
	new User[MAX_NAME_LENGTH];
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if(g_block){
		if(g_override){
			g_UserMenu[UserIndex]=0;
			g_override=0;
		}else{
			welcome_menu(User,UserIndex);
			say("[TEAMBLOCK] Teamchange not allowed at the moment!");
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

//Menu to overlay the teamselect menu
welcome_menu(User[],UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Hostname[MAX_DATA_LENGTH];
	getstrvar("hostname",Hostname,MAX_DATA_LENGTH);
	snprintf(Data,MAX_DATA_LENGTH,"\yWelcome to %s^n^n\rTeamselect disabled at the moment!^n^n\yPlease wait till you are^nallowed to select a team!",Hostname);
	menu(User,Data,1024,8);
	g_UserMenu[UserIndex]=1;
}

//block menuselect for all who are viewing welcome menu
public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	new User[MAX_NAME_LENGTH];
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if(g_UserMenu[UserIndex] && g_block){
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
	g_SpecMode[UserIndex]=0;
	g_UserMenu[UserIndex]=0;
	return PLUGIN_CONTINUE;
}

reset_all(){
	new i;
	new maxplayers=maxplayercount();
	for(i=1;i<=maxplayers;i++){
		g_UserMenu[i]=0;
	}
}

